/*
    exDOS - Experimental 32 Bit protected mode scripted operating system
    (C) 2005 Jason Hunt
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com

    File: system.h
*/

#ifndef SYSTEM_H
#define SYSTEM_H

#include "process.h"

byte in_byte(word port);                // Reture value from IO port
void out_byte(word port, byte value);   // Write value to IO port

void cli( void );                       // Disable interrupts
void sti( void );                       // Enable interrupts

dword get_esp( void );                  // Return the stack pointer

void reboot( void );                    // Reboot the machine

void load_idt(void* idt);               // Load the interrupt descriptor table

void empty_intr_0_7(void);              // Empty interrupt 0x20 - 0x27
void empty_intr_8_F(void);              // Empty interrupt 0x28 - 0x2f

void empty_exception(void);             // Empty exception

void keyboard_intr_wrap( void );        // Assembly wrapper for keyboad int
void timer_intr_wrap( void );           // Assembly wrapper for timer
void floppy_intr_wrap( void );           // Assembly wrapper for timer
void syscall_intr_wrap( void );         // System call interface

void enable_nmi( void );                // Enable NMI

void vga_screen_up(void);               // Scroll the screen up one line
void vga_clear_screen(void);               // Scroll the screen up one line

#endif


